﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;
using Styx.CommonBot;

namespace DoUntil
{
    public class DoUntil : HBPlugin
    {
        public static DoUntil _thisInstance;
        public UInt32 ItemID, ItemCount = 0;

        public DoUntil()
        {
            _thisInstance = this;
        }

        public void Log(String Text)
        {
             Logging.Write(System.Windows.Media.Color.FromRgb(100, 149, 237), String.Format("[{0}]: {1}", Name, Text)); /* Cornflower Blue and Prefixxing */
        }

        #region Overrides
        public override Version Version
        {
            get { return new Version(1, 0, 0, 0); }
        }

        public override string Author
        {
            get { return "Darkchaos"; }
        }

        public override string Name
        {
            get { return "DoUntil"; }
        }

        public override string ButtonText
        {
            get { return "Settings"; }
        }

        public override bool WantButton
        {
            get { return true; }
        }

        public override void OnButtonPress()
        {
            if (!SettingsDialog.IsValid)
                new SettingsDialog().Show();
            else
                SettingsDialog.Instance.Activate();
        }

        public override void OnEnable()
        {
           Log(String.Format("{0} Version {1} by {2} successfully loaded!", Name, Version, Author));
        }

        public override void  OnDisable()
        {
 	        Log(String.Format("Thanks for using {1}!", Name));
        }
        #endregion

        public override void Pulse()
        {
           if (StyxWoW.Me.Combat)
                return;

           UInt32 count = 0;

           foreach (WoWItem itm in StyxWoW.Me.BagItems)
               if (itm.ItemInfo.Id == ItemID)
                   count += itm.StackCount;

           if (count >= ItemCount)
           {
               Log(String.Format("We have {0} items now, it is enough. We will staph ;)", count));
               TreeRoot.Stop("DoUntil Plugin triggered stop");
           }
        }
    }
}
